
#include <stdio.h>
//#include <iostream.h>

int main(int argc, char** argv) {
  int p, s, base ;

  printf("p?: ") ;
  scanf("%d", &p) ;
  printf("s?: ") ;
  scanf("%d", &s) ;
  printf("base?: ") ;
  scanf("%d", &base) ;

  int f, f_s, i_0 ;

  // Compute `f', the GCD of `p' and `s', and `f_s', a solution of
  //     f_s * s = f  mod p

  int g, g_s ;

  f = p ;
  f_s = 0 ;
  if(s > 0) {
    g   = s ;
    g_s = 1 ;
  }
  else {
    g   = -s ;
    g_s = -1 ;
  }
  while(g) {
    int temp ;

    const r = f / g ;

    temp = g ;
    g    = f - r * g ;
    f    = temp ;
  
    temp = g_s ;
    g_s  = f_s - r * g_s ;
    f_s  = temp ;
  }

  printf("f = %d f_s = %d\n", f, f_s) ;

  for(int coord = 0 ; coord < p ; coord++) {
    // Compute `i_0', the smallest non-negative solution of 
    //     base + i_0 * s = coord  mod p

    const c = coord - base ;
    if(c % f == 0) {
      const cf_s = (c * f_s) % p ;
      if(cf_s >= 0)
	i_0 = cf_s / f ;
      else
	i_0 = (p + cf_s) / f ;
      printf("%2d: %2d\n", coord, i_0) ;
    }
    else
      printf("%2d:\n", coord) ;
  }
}

